<script lang="ts">
    import { getProductsAPI } from "src/apis/get-products";
    import { numberWithCommas } from "src/functions/comma-number";
    import { Page } from "src/page";
    import { onMount } from "svelte";
    import {
        productSelectedStore,
        pageSelectedStore,
        productsStore,
    } from "src/store";
    import type { ProductModel } from "src/models/product.type";

    let moreNum =
        $productsStore.length / 5 > 10
            ? +($productsStore.length / 5)
            : +$productsStore.length;

    let arrMoreProduct: ProductModel[] = [];

    onMount(async () => {
        await getProductsAPI();
        loopItems();
    });

    function moreProduct() {
        if (moreNum + moreNum >= $productsStore.length) {
            moreNum = $productsStore.length;
        } else {
            moreNum += moreNum;
        }

        loopItems();
    }

    // // เมื่อ productsStore มีการเปลี่ยนแปลง จะเรียก function loopItems นี้
    productsStore.subscribe((resp) => {
        loopItems();
    });

    function loopItems() {
        if ($productsStore.length > 10) {
            arrMoreProduct = [];
            for (let i = 0; i < moreNum; i++) {
                arrMoreProduct.push($productsStore[i]);
            }
            arrMoreProduct = arrMoreProduct;
        } else {
            arrMoreProduct = $productsStore;
        }
    }

    function onClickProduct(productSelect: ProductModel) {
        $productSelectedStore = productSelect;
        $pageSelectedStore = Page["PRODUCT_DETAIL"];
    }
</script>

<div class="w-full">
    <div
        class="grid xl:grid-cols-4 lg:grid-cols-3 sm:grid-cols-2 grid-cols-1 gap-2 place-items-start"
    >
        {#each arrMoreProduct as product, index}
            <div
                on:click={() => onClickProduct(product)}
                class="shadow-lg rounded-2xl bg-white w-64 p-2 mx-auto m-5 cursor-pointer"
            >
                <img
                    src={product.image[0].url}
                    alt="adidas"
                    class="w-36 h-36 p-1 m-auto border border-gray-200"
                />
                <div class="bg-green-600 m-3 p-4 rounded-lg">
                    <p class="text-gray-800 text-xl font-bold ">
                        {product.productName || "-"}
                    </p>
                    <div class="flex items-center justify-between ">
                        <p class="text-white font-bold text-2xl">
                            {#if product.discount > 0}
                                <span
                                    class="mr-2 text-base leading-5 text-green-300 line-through"
                                >
                                    ฿{numberWithCommas(product.price)}
                                </span>
                            {/if}
                            ฿{numberWithCommas(
                                product.price -
                                    (product.price * product.discount) / 100
                            )}
                        </p>
                    </div>
                </div>
            </div>
        {/each}
    </div>

    {#if $productsStore.length == 0}
        <div class="flex justify-center items-center m-24">
            <img alt="item_notfound" class="w-20 h-20" src="./imgs/product_not_found.png" />
            <p class="py-10 px-2 text-gray-400">ไม่มีสินค้าที่ต้องการ</p>
        </div>
    {/if}
    {#if moreNum != $productsStore.length && $productsStore.length > 10}
        <div
            class="w-full px-10 mt-10 mb-20 flex justify-center border-t border-gray-500"
        >
            <button
                on:click={moreProduct}
                class="px-10 py-3 bg-green-700 text-white cursor-pointer mt-10"
                >ดูสินค้าเพิ่มเติม</button
            >
        </div>
    {/if}
</div>
